#ifndef	___SHINTAAbout_H_
#define	___SHINTAAbout_H_
//------------------------------------------------------------------------------
// BeOS
#include <Box.h>
#include <interface/StringView.h>
// C++
#include <string>
// Add2
#include "GUIBase.h"
#include "SHINTAIAPs.h"
//------------------------------------------------------------------------------
// LKKs
const char	LKK_ABOUT_WIN_TITLE[] = "About %AppName%";
const char	LKK_ABOUT_TRANSLATOR_INFO[] = "%LangNameInNative% translation by %TranslatorName%";	// SHINTAAbout.cpp では使われないが、全アプリで使うことになるだろうからここで定義
const char	LKK_ABOUT_STRVIEW_USED_BY[] = "This software is used by the follow person.";
const char	LKK_ABOUT_STRVIEW_USER_NAME[] = "Shousei User Name: %Str%";
const char	LKK_ABOUT_UNREG_USER_NAME[] = "(Unregisterd)";
const char	LKK_ABOUT_STRVIEW_USER_NUM[] = "Shousei User Number: %Str%";
const char	LKK_ABOUT_UNREG_USER_NUM[] = "(Not Issued)";
const char	LKK_ABOUT_BUTTON_OK[] = "OK";
//------------------------------------------------------------------------------
// LKRs
const char	LKR_ABOUT_APP_AUTHOR[] = "%AppAuthor%";
const char	LKR_ABOUT_APP_NAME[] = "%AppName%";
const char	LKR_ABOUT_LANG_NAME_IN_NATIVE[] = "%LangNameInNative%";
const char	LKR_ABOUT_STR[] = "%Str%";
const char	LKR_ABOUT_TRANSLATOR_NAME[] = "%TranslatorName%";
//------------------------------------------------------------------------------
// LKVs
const char	LKV_ABOUT_LANG_NAME_IN_NATIVE[] = "$LangNameInNative$";
const char	LKV_ABOUT_LANG_NAME_IN_ENGLISH[] = "$LangNameInEnglish$";
const char	LKV_ABOUT_TRANSLATOR_NAME[] = "$TranslatorName$";
const char	LKV_ABOUT_TRANSLATOR_MAIL[] = "$TranslatorMail$";
//------------------------------------------------------------------------------
class	TAppInfoView;
//==============================================================================
/* ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
TSHINTAAboutWindow 直属のビュー
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
class	TSHINTAAboutView : public TDialogView
{
public:
	TSHINTAAboutView(BRect oFrame);
	TSHINTAAboutView(BMessage* oArc);
	~TSHINTAAboutView();

	virtual status_t	SetAppInfo(const char* oAppName, const char* oAppVer,
			const char* oCright) = 0;						// 情報の設定
	virtual status_t	SetIAPRef(TInterAppPrefs* oIAPRef);	// ＳＨＩＮＴＡ共通環境設定へのポインタを設定
	virtual status_t	SetTranslatorInfo(const char* oTranslatorInfo) = 0;	// 翻訳者情報の設定

protected:
	virtual void	AllAttached();
	virtual void	AttachedToWindow();
	virtual void	ButtonOKClicked();
	virtual void	MessageReceived(BMessage* oMsg);

	TInterAppPrefs*	mIAPRef;							// IAP へのポインタ

private:
	typedef	TDialogView	SUPER;

	void			Init();
	void			SetViewLabel();
};
//==============================================================================
/* ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
TAppInfoView のみを子として持つ About ビュー
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
class	TSimpleAboutView : public TSHINTAAboutView
{
public:
	TSimpleAboutView(BRect oFrame, TAppInfoView* oAppInfoView = NULL);
	~TSimpleAboutView();

	virtual void		LanguageChanged();
	virtual status_t	SetAppInfo(const char* oAppName, const char* oAppVer, const char* oCright);	// 情報の設定
	virtual status_t	SetIAPRef(TInterAppPrefs* oIAPRef);	// ＳＨＩＮＴＡ共通環境設定へのポインタを設定
	virtual status_t	SetTranslatorInfo(const char* oTranslatorInfo);	// 翻訳者情報の設定

protected:
	virtual void	AllAttached();
	virtual void	AttachedToWindow();

private:
	typedef	TSHINTAAboutView	SUPER;

	void			SetViewLabel();

	BButton*			mButtonOK;							// Button OK
	TAppInfoView*		mAppInfoView;
};
//==============================================================================
/* ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
アプリケーション情報を表示するためのビュー（About ビューではなく、About ビューの子供として貼り付けられるビュー）
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
class	TAppInfoView : public TDialogView
{
public:
	TAppInfoView(BRect oFrame);
	~TAppInfoView();

	virtual void		IAPChanged(BMessage* oMsg);
	virtual void		LanguageChanged();
	status_t			SetAppInfo(const char* oAppName, const char* oAppVer, const char* oCright);	// 情報の設定
	status_t			SetTranslatorInfo(const char* oTranslatorInfo);	// 翻訳者情報の設定
	status_t			SetIAPRef(TInterAppPrefs* oIAPRef);		// ＳＨＩＮＴＡ共通環境設定へのポインタを設定

protected:
	virtual void		AttachedToWindow();
	virtual void		Draw(BRect oRect);

	BBitmap*			mIcon;									// アイコン
	BBox*				mBoxSep1;
	BBox*				mBoxSep2;
	BStringView*		mStrViewAppName;						// StrView アプリケーション名
	BStringView*		mStrViewAppVer;							// StrView バージョン
	BStringView*		mStrViewCright;							// StrView コピーライト
	BStringView*		mStrViewTranslator;						// StrView 翻訳者名
	BStringView*		mStrViewUsedBy;							// StrView 使用されています
	BStringView*		mStrViewUserName;						// StrView 翔星ユーザー名
	BStringView*		mStrViewUserNum;						// StrView 翔星ユーザー番号
	TInterAppPrefs*		mIAPRef;

private:
	typedef	TDialogView	SUPER;

	status_t		SetAppInfo();
	status_t		SetShouseiInfo();							// 翔星情報を表示
	status_t		SetTranslatorInfo();
	void			SetViewLabel();								// 表示を更新

	string			mAppName;
	string			mAppVer;
	string			mCright;
	string			mTranslatorInfo;
};
//==============================================================================
class TSHINTAAboutWindow : public TDialogWindow
{
public:
	TSHINTAAboutWindow(BRect oFrame, TSHINTAAboutView* oCustomView = NULL);
	~TSHINTAAboutWindow();

	virtual void		LanguageChanged();
	virtual status_t	SetAppInfo(const char* oAppName, const char* oAppVer,
			const char* oCright);							// 情報の設定
	virtual status_t	SetIAPRef(TInterAppPrefs* oIAPRef);	// ＳＨＩＮＴＡ共通環境設定へのポインタを設定
	virtual status_t	SetTranslatorInfo(const char* oTranslatorInfo);	// 翻訳者情報の設定

private:
	typedef	TDialogWindow	SUPER;

	void			SetWinTitle();

	string				mCachedAppName;	// SetAppInfo() の時に横取り
	TSHINTAAboutView*	mAboutView;		// メインビュー
};
//==============================================================================
#endif	// ___SHINTAAbout_H_
